Index: /anuga_work/development/anuga_1d/domain.py
===================================================================
--- /anuga_work/development/anuga_1d/domain.py	(revision 7824)
+++ /anuga_work/development/anuga_1d/domain.py	(revision 7825)
@@ -661,11 +661,11 @@
 
 
-        #Do the expression stuff
-        if kwargs.has_key('expression'):
-            expression = kwargs['expression']
-            del kwargs['expression']
-
-            Q = self.create_quantity_from_expression(expression)
-            kwargs['quantity'] = Q
+#        #Do the expression stuff
+#        if kwargs.has_key('expression'):
+#            expression = kwargs['expression']
+#            del kwargs['expression']
+#
+#            Q = self.create_quantity_from_expression(expression)
+#            kwargs['quantity'] = Q
         
         #Assign values
@@ -1570,5 +1570,5 @@
             for name in self.conserved_quantities:
                 Q = self.quantities[name]
-                Q.explicit_update[:] = 0.0
+                Q.explicit_update[:,] = 0.0
 
         for f in self.forcing_terms:
Index: /anuga_work/development/anuga_1d/quantity.py
===================================================================
--- /anuga_work/development/anuga_1d/quantity.py	(revision 7824)
+++ /anuga_work/development/anuga_1d/quantity.py	(revision 7825)
@@ -237,11 +237,11 @@
     def set_values_from_constant(self,numeric):
 
-        self.vertex_values[:]   = numeric
-        self.centroid_values[:] = numeric
+        self.vertex_values[:,:]   = numeric
+        self.centroid_values[:,] = numeric
 
 
     def set_values_from_array(self,numeric):
 
-        self.vertex_values[:]   = numeric
+        self.vertex_values[:,:]   = numeric
         self.interpolate()
 
@@ -249,11 +249,11 @@
     def set_values_from_quantity(self,quantity):
 
-        self.vertex_values[:]   = quantity.vertex_values
-        self.centroid_values[:] = quantity.centroid_values
+        self.vertex_values[:,:]   = quantity.vertex_values
+        self.centroid_values[:,] = quantity.centroid_values
 
     def set_values_from_function(self,function):
 
-        self.vertex_values[:]   = map(function, self.domain.vertices)
-        self.centroid_values[:] = map(function, self.domain.centroids)
+        self.vertex_values[:,:]   = map(function, self.domain.vertices)
+        self.centroid_values[:,] = map(function, self.domain.centroids)
 
 
@@ -1097,10 +1097,10 @@
         #backup_centroid_values(self)
 
-        self.centroid_backup_values[:] = (self.centroid_values).astype('f')
+        self.centroid_backup_values[:,] = (self.centroid_values).astype('f')
 
     def saxpy_centroid_values(self,a,b):
         # Call correct module function
         # (either from this module or C-extension)
-        self.centroid_values[:] = (a*self.centroid_values + b*self.centroid_backup_values).astype('f')
+        self.centroid_values[:,] = (a*self.centroid_values + b*self.centroid_backup_values).astype('f')
         
 
Index: /anuga_work/development/anuga_1d/shallow_water_domain.py
===================================================================
--- /anuga_work/development/anuga_1d/shallow_water_domain.py	(revision 7824)
+++ /anuga_work/development/anuga_1d/shallow_water_domain.py	(revision 7825)
@@ -412,5 +412,5 @@
     for k in range(N):
 
-        flux[:] = 0.  #Reset work array
+        flux[:,] = 0.  #Reset work array
         for i in range(2):
             #Quantities inside volume facing neighbour i
@@ -507,5 +507,5 @@
     for k in range(N):
 
-        flux[:] = 0.  #Reset work array
+        flux[:,] = 0.  #Reset work array
         #for i in range(3):
         for i in range(2):
Index: /anuga_work/development/anuga_1d/shallow_water_vel_domain.py
===================================================================
--- /anuga_work/development/anuga_1d/shallow_water_vel_domain.py	(revision 7824)
+++ /anuga_work/development/anuga_1d/shallow_water_vel_domain.py	(revision 7825)
@@ -264,5 +264,8 @@
     uh_V = domain.quantities['xmomentum'].vertex_values	
 
-    h_V[:]    = w_V - z_V
+    #print w_V
+    #print z_V
+    
+    h_V[:,:]    = w_V - z_V
     for i in range(len(h_C)):
         for j in range(2):
@@ -275,5 +278,5 @@
                 w_V[i,(j+1)%2] = w_V[i,(j+1)%2] + dh
                 
-    uh_V[:] = u_V * h_V
+    uh_V[:,:] = u_V * h_V
 
     
@@ -341,5 +344,5 @@
     uh_V = domain.quantities['xmomentum'].vertex_values	
 
-    h_V[:]    = w_V - z_V
+    h_V[:,:]    = w_V - z_V
 
     for i in range(len(h_C)):
Index: /anuga_work/development/anuga_1d/test_quantity.py
===================================================================
--- /anuga_work/development/anuga_1d/test_quantity.py	(revision 7824)
+++ /anuga_work/development/anuga_1d/test_quantity.py	(revision 7825)
@@ -578,9 +578,9 @@
         #Set explicit_update
         explicit_update = array( [4.,3.,2.,1.] )
-        quantity.explicit_update[:] = explicit_update
+        quantity.explicit_update[:,] = explicit_update
 
         #Set semi implicit update
         semi_implicit_update = array( [1.,1.,1.,1.] )
-        quantity.semi_implicit_update[:] = semi_implicit_update
+        quantity.semi_implicit_update[:,] = semi_implicit_update
 
         #Update with given timestep
Index: /anuga_work/development/anuga_1d/test_shallow_water_domain.py
===================================================================
--- /anuga_work/development/anuga_1d/test_shallow_water_domain.py	(revision 7824)
+++ /anuga_work/development/anuga_1d/test_shallow_water_domain.py	(revision 7825)
@@ -275,5 +275,5 @@
     for k in range(N):
 
-        flux[:] = 0.  #Reset work array
+        flux[:,] = 0.  #Reset work array
         #for i in range(3):
         for i in range(2):
Index: /anuga_work/development/anuga_1d/test_shallow_water_vel_domain.py
===================================================================
--- /anuga_work/development/anuga_1d/test_shallow_water_vel_domain.py	(revision 7824)
+++ /anuga_work/development/anuga_1d/test_shallow_water_vel_domain.py	(revision 7825)
@@ -114,18 +114,19 @@
         domain.compute_fluxes()
         
-        print domain.quantities['stage'].vertex_values
-        print domain.quantities['xmomentum'].vertex_values
-        print domain.quantities['elevation'].vertex_values
-        print domain.quantities['height'].vertex_values
-        print domain.quantities['velocity'].vertex_values
-
-        print domain.quantities['stage'].boundary_values
-        print domain.quantities['xmomentum'].boundary_values
-        print domain.quantities['elevation'].boundary_values
-        print domain.quantities['height'].boundary_values
-        print domain.quantities['velocity'].boundary_values
+#        print domain.quantities['stage'].vertex_values
+#        print domain.quantities['xmomentum'].vertex_values
+#        print domain.quantities['elevation'].vertex_values
+#        print domain.quantities['height'].vertex_values
+#        print domain.quantities['velocity'].vertex_values
+#
+#        print domain.quantities['stage'].boundary_values
+#        print domain.quantities['xmomentum'].boundary_values
+#        print domain.quantities['elevation'].boundary_values
+#        print domain.quantities['height'].boundary_values
+#        print domain.quantities['velocity'].boundary_values
         
         print domain.quantities['stage'].explicit_update
         print domain.quantities['xmomentum'].explicit_update
+
         print stage_ud
         print xmom_ud
@@ -343,5 +344,5 @@
     for k in range(N):
 
-        flux[:] = 0.  #Reset work array
+        flux[:,] = 0.  #Reset work array
         #for i in range(3):
         for i in range(2):