Index: trunk/anuga_core/documentation/user_manual/demos/buildings.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/demos/buildings.py	(revision 7828)
+++ trunk/anuga_core/documentation/user_manual/demos/buildings.py	(revision 7838)
@@ -26,5 +26,5 @@
 length = 50
 width = 10
-resolution = 0.15 # make this number smaller to make the simulation more accurate
+resolution = 1.0 # make this number smaller to make the simulation more accurate
 
 # Create the "world" as a long, skinny channel
@@ -73,13 +73,20 @@
                     })
 
+import cPickle
+
 #------------------------------------------------------------------------------
 # Evolve system through time
 #------------------------------------------------------------------------------
-for t in domain.evolve(yieldstep=0.2, finaltime=15.0):
-    print domain.timestepping_statistics()
+#for t in domain.evolve(yieldstep=0.2, finaltime=15.0):
+#    print domain.timestepping_statistics()
+
+#cPickle.dump(domain, open('domain_pickle.txt', 'w'))
+ 
+domain = cPickle.load(open('domain_pickle.txt'))
+
     
 # now turn off the tap
 domain.set_boundary({'left': Bo})
 
-for t in domain.evolve(yieldstep=0.2, finaltime=30.0):
+for t in domain.evolve(yieldstep=0.1, finaltime=30.0):
     print domain.timestepping_statistics()        
Index: trunk/anuga_core/documentation/user_manual/demos/cairns/ExportResults.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/demos/cairns/ExportResults.py	(revision 7828)
+++ trunk/anuga_core/documentation/user_manual/demos/cairns/ExportResults.py	(revision 7838)
@@ -3,11 +3,8 @@
 import project
 
-from anuga.shallow_water.data_manager import sww2dem
-from anuga.abstract_2d_finite_volumes.util import start_screen_catcher
-from os import sep
+import anuga
 
 scenario = 'slide'
-
-name = scenario + sep + scenario + 'source'
+name = 'cairns_' + scenario
 
 print 'output dir:', name
@@ -36,6 +33,6 @@
 print 'start sww2dem'
 
-sww2dem(name,
-        basename_out=outname,
+anuga.sww2dem(name+'.sww',
+        outname+'.ers',
         quantity=quantityname,
         cellsize=100,      
@@ -45,4 +42,3 @@
         northing_max=project.northingmax,        
         reduction=max, 
-        verbose=True,
-        format='ers')
+        verbose=True)
Index: trunk/anuga_core/documentation/user_manual/demos/cairns/GetTimeseries.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/demos/cairns/GetTimeseries.py	(revision 7828)
+++ trunk/anuga_core/documentation/user_manual/demos/cairns/GetTimeseries.py	(revision 7838)
@@ -11,12 +11,12 @@
 from os import sep
 import project
-from anuga.abstract_2d_finite_volumes.util import sww2csv_gauges,csv2timeseries_graphs
+import anuga
 
-sww2csv_gauges('slide'+sep+'slidesource.sww',
+anuga.sww2csv_gauges('cairns_slide.sww',
                 project.gauge_filename,
                 quantities=['stage','speed','depth','elevation'],
                 verbose=True)
                 
-sww2csv_gauges('fixed_wave'+sep+'fixed_wavesource.sww',
+anuga.sww2csv_gauges('cairns_fixed_wave.sww',
                project.gauge_filename,
                quantities=['stage', 'speed','depth','elevation'],
@@ -25,5 +25,5 @@
 try: 
     import pylab
-    csv2timeseries_graphs(directories_dic={'slide'+sep: ['Slide',0, 0],
+    anuga.csv2timeseries_graphs(directories_dic={'slide'+sep: ['Slide',0, 0],
                                            'fixed_wave'+sep: ['Fixed Wave',0,0]},
                           output_dir='fixed_wave'+sep,
Index: trunk/anuga_core/documentation/user_manual/demos/cairns/project.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/demos/cairns/project.py	(revision 7828)
+++ trunk/anuga_core/documentation/user_manual/demos/cairns/project.py	(revision 7838)
@@ -3,18 +3,17 @@
 """
 
-from anuga.geometry.polygon import read_polygon, plot_polygons, \
-                                    polygon_area, is_inside_polygon
+import anuga
 
 #------------------------------------------------------------------------------
 # Define scenario as either slide or fixed_wave. Choose one.
 #------------------------------------------------------------------------------
-#scenario = 'fixed_wave' # Huge wave applied at the boundary
-scenario = 'slide'       # Slide wave form applied inside the domain
+scenario = 'fixed_wave' # Huge wave applied at the boundary
+#scenario = 'slide'       # Slide wave form applied inside the domain
 
 #------------------------------------------------------------------------------
 # Filenames
 #------------------------------------------------------------------------------
-demname_stem = 'cairns'
-meshname = demname + '.msh'
+name_stem = 'cairns'
+meshname = name_stem + '.msh'
 
 # Filename for locations where timeseries are to be produced
@@ -25,7 +24,7 @@
 #------------------------------------------------------------------------------
 # bounding polygon for study area
-bounding_polygon = read_polygon('extent.csv')
+bounding_polygon = anuga.read_polygon('extent.csv')
 
-A = polygon_area(bounding_polygon) / 1000000.0
+A = anuga.polygon_area(bounding_polygon) / 1000000.0
 print 'Area of bounding polygon = %.2f km^2' % A
 
@@ -34,10 +33,10 @@
 #------------------------------------------------------------------------------
 # Read interior polygons
-poly_cairns = read_polygon('cairns.csv')
-poly_island0 = read_polygon('islands.csv')
-poly_island1 = read_polygon('islands1.csv')
-poly_island2 = read_polygon('islands2.csv')
-poly_island3 = read_polygon('islands3.csv')
-poly_shallow = read_polygon('shallow.csv')
+poly_cairns = anuga.read_polygon('cairns.csv')
+poly_island0 = anuga.read_polygon('islands.csv')
+poly_island1 = anuga.read_polygon('islands1.csv')
+poly_island2 = anuga.read_polygon('islands2.csv')
+poly_island3 = anuga.read_polygon('islands3.csv')
+poly_shallow = anuga.read_polygon('shallow.csv')
 
 # Optionally plot points making up these polygons
Index: trunk/anuga_core/documentation/user_manual/demos/cairns/runcairns.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/demos/cairns/runcairns.py	(revision 7828)
+++ trunk/anuga_core/documentation/user_manual/demos/cairns/runcairns.py	(revision 7838)
@@ -31,8 +31,8 @@
 #------------------------------------------------------------------------------
 # Create DEM from asc data
-anuga.asc2dem(project.demname_stem+'.asc', use_cache=True, verbose=True)
+anuga.asc2dem(project.name_stem+'.asc', use_cache=True, verbose=True)
 
 # Create pts file for onshore DEM
-anuga.dem2pts(project.demname_stem+'.dem', use_cache=True, verbose=True)
+anuga.dem2pts(project.name_stem+'.dem', use_cache=True, verbose=True)
 
 #------------------------------------------------------------------------------
@@ -71,5 +71,5 @@
 domain.set_quantity('friction', 0.0) 
 domain.set_quantity('elevation', 
-                    filename=project.demname + '.pts',
+                    filename=project.name_stem + '.pts',
                     use_cache=True,
                     verbose=True,
Index: trunk/anuga_core/documentation/user_manual/demos/channel1.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/demos/channel1.py	(revision 7828)
+++ trunk/anuga_core/documentation/user_manual/demos/channel1.py	(revision 7838)
@@ -11,12 +11,9 @@
 import anuga
 
-# Import rectangular cross mesh generator
-from anuga.abstract_2d_finite_volumes.mesh_factory import rectangular_cross
-
 
 #------------------------------------------------------------------------------
 # Setup computational domain
 #------------------------------------------------------------------------------
-points, vertices, boundary = rectangular_cross(10, 5,
+points, vertices, boundary = anuga.rectangular_cross(10, 5,
                                                len1=10.0, len2=5.0) # Mesh
 
Index: trunk/anuga_core/documentation/user_manual/demos/runup.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/demos/runup.py	(revision 7828)
+++ trunk/anuga_core/documentation/user_manual/demos/runup.py	(revision 7838)
@@ -8,10 +8,5 @@
 # Import necessary modules
 #------------------------------------------------------------------------------
-from anuga.abstract_2d_finite_volumes.mesh_factory import rectangular_cross
-from anuga.shallow_water import Domain
-from anuga.shallow_water import Reflective_boundary
-from anuga.shallow_water import Dirichlet_boundary
-from anuga.shallow_water import Time_boundary
-from anuga.shallow_water import Transmissive_boundary
+import anuga
 
 from math import sin, pi, exp
@@ -20,9 +15,9 @@
 # Setup computational domain
 #------------------------------------------------------------------------------
-points, vertices, boundary = rectangular_cross(10, 10) # Basic mesh
+points, vertices, boundary = anuga.rectangular_cross(10, 10) # Basic mesh
 
-domain = Domain(points, vertices, boundary) # Create domain
-domain.set_name('runup')                    # Output to file runup.sww
-domain.set_datadir('.')                     # Use current directory for output
+domain = anuga.Domain(points, vertices, boundary)   # Create domain
+domain.set_name('runup')                            # Output to file runup.sww
+domain.set_datadir('.')                             # Use current folder
 
 #------------------------------------------------------------------------------
@@ -40,8 +35,8 @@
 # Setup boundary conditions
 #------------------------------------------------------------------------------
-Br = Reflective_boundary(domain)      # Solid reflective wall
-Bt = Transmissive_boundary(domain)    # Continue all values on boundary 
-Bd = Dirichlet_boundary([-0.2,0.,0.]) # Constant boundary values
-Bw = Time_boundary(domain=domain,     # Time dependent boundary  
+Br = anuga.Reflective_boundary(domain)      # Solid reflective wall
+Bt = anuga.Transmissive_boundary(domain)    # Continue all values on boundary 
+Bd = anuga.Dirichlet_boundary([-0.2,0.,0.]) # Constant boundary values
+Bw = anuga.Time_boundary(domain=domain,     # Time dependent boundary  
                    f=lambda t: [(0.1*sin(t*2*pi)-0.3)*exp(-t), 0.0, 0.0])
 